Listing 2 -- PICKLIST Function

FUNCTION picklist
PARAMETERS chk_file, srch_fld, ret_fld, s_row, ;
           s_col
PRIVATE chk_file, srch_fld, ret_fld, s_row 
PRIVATE s_col, var_name, var_val, wasopen
PRIVATE cur_buff, cur_exact, pcount, rvalue
PRIVATE isfound, b_fields, win_wid
PRIVATE g_row, g_col

PUBLIC foxpro                &&  for Xbase version 
rvalue = .t.

var_name = varread()         &&  name of the GET
var_val = &var_name          &&  value of the GET

IF foxpro                    &&  FoxPro code
  pcount = parameters()      &&  how many passed?

  DO CASE

    CASE pcount = 2          &&  only two params
      ret_fld = srch_fld     &&  return srch fld

    CASE pcount >= 3         &&  three or more

      IF empty(ret_fld)       &&  passed as a null
        ret_fld = srch_fld
      ENDIF

  ENDCASE

ELSE                          &&  dBase IV code

  IF len(trim(ret_fld)) = 0   &&  passed as a null
    ret_fld = srch_fld
  ENDIF

ENDIF

s_row = scr_row()             &&  browse row 
s_col = scr_col()             &&  browse column

cur_buff = alias()            &&  where are we?
cur_exact = set('exact') = 'ON'
SET EXACT ON

IF .not. used(chk_file)       &&  file not open

  IF foxpro                   &&  FoxPro?
    SELECT 0                  &&  Fox code
  ELSE                        &&  dBase IV?
    SELECT select()           &&  dBase IV code
  ENDIF

  USE &chk_file               &&  open sthe file
  SET ORDER TO key(1)         &&  set the index
  wasopen = .f.               &&  set the flag
ELSE
  SELECT (chk_file)
  wasopen = .t.  
ENDIF

g_row = row()                 &&  GET row & col
g_col = iif(len(trim(var_val))=0,col(), col()-;
            len(&ret_fld))

IF len(trim(var_val)) = 0    &&  no data in field
  isfound = .f.              &&  automatic lookup
ELSE
  isfound = seek(var_val)    &&  search table
ENDIF

IF .not. isfound             &&  not in table!

  GO TOP

***  make sure browse fits on the screen

  IF ret_fld = srch_fld      && one field browse
    win_wid = len(&srch_fld) + 3
    b_fields = srch_fld
  ELSE
    win_wid = len(&srch_fld) + len(&ret_fld) + 5
    b_fields = srch_fld + ', ' + ret_fld
  ENDIF

  s_col = iif(s_col+win_wid>77,77-win_wid,s_col)
  s_row = iif(s_row>14,14,s_row)

*** set up browse window

  DEFINE WINDOW pick_bro FROM s_row,s_col+2 TO ;
                s_row+10,s_col+ win_wid+2 PANEL
  ACTIVATE WINDOW pick_bro

  IF foxpro
    ON KEY LABEL enter KEYBOARD chr(23)
  ELSE 
    ON KEY LABEL ctrl-m KEYBOARD chr(23)
  ENDIF

  BROWSE FIELDS &b_fields FREEZE &srch_fld NOEDIT;
         NOAPPEND NODELETE WINDOW pick_bro

  IF foxpro
    ON KEY LABEL enter
  ELSE
    ON KEY LABEL ctrl-m
  ENDIF

  RELEASE WINDOW pick_bro

  IF lastkey() # 27
    STORE &ret_fld to &var_name
  ELSE
    rvalue = .f.
  ENDIF

ELSE
  STORE &ret_fld to &var_name
ENDIF

IF .not. foxpro             &&  dBase IV code
  DO pk_show                &&  repaint GET
ENDIF

IF .not. cur_exact
  SET EXACT off
ENDIF

IF .not. wasopen            &&  file was closed
  USE
ENDIF

IF len(cur_buff) # 0        &&  switch to old buff
  SELECT (cur_buff)
ELSE 

  IF foxpro
    SELECT 0                &&  FoxPro code
  ELSE
    SELECT select()         &&  dBase IV code
  ENDIF

ENDIF

RETURN(rvalue)

********


FUNCTION scr_row

IF type('s_row') # 'N'
  RETURN(row())
ELSE
  RETURN(s_row)
ENDIF

********

FUNCTION scr_col

IF type('s_col') # 'N'        &&  no param passed


  IF len(trim(var_val)) = 0   &&  empty field
    RETURN col() + len(var_val)
  ELSE
    RETURN col()
  ENDIF

ELSE
  RETURN(s_col)
ENDIF

********

PROCEDURE pk_show
PRIVATE ms_colors, cur_color, opt_color

***  dBase IV routine to properly paint the
***  correct choice in the GET

ms_colors = set('attributes')
cur_color = substr(ms_colors,1,at(',',ms_colors)-1)
opt_color = substr(ms_colors,rat(',',ms_colors)+1)

SET COLOR OF NORMAL TO &opt_color

@ g_row,g_col say space(len(&ret_fld))
@ g_row,g_col say &var_name
SET COLOR OF NORMAL TO &cur_color

RETURN

********

